# encoding: utf-8

module Nanoc::Filters
  class RDoc < Nanoc::Filter

    if /^2.0/ =~ RUBY_VERSION
      requires 'rdoc'
    else
      requires 'rdoc/markup', 'rdoc/markup/to_html'
    end

    # Runs the content through [RDoc::Markup](http://rdoc.rubyforge.org/RDoc/Markup.html).
    # This method takes no options.
    #
    # @param [String] content The content to filter
    #
    # @return [String] The filtered content
    def run(content, params={})
      if /^2.0/ =~ RUBY_VERSION
        options = ::RDoc::Options.new
        to_html = ::RDoc::Markup::ToHtml.new(options)
      else
        to_html = ::RDoc::Markup::ToHtml.new
      end
      ::RDoc::Markup.new.convert(content, to_html)
    end

  end
end
